part of 'package:contentsquare/src/piledriver2045.dart';


@visibleForTesting
abstract class red_ghost250<Input, Output> {
  
  red_ghost250() {
    _nomad537<Input>();
    _nomad537<Output>();
  }

  static void _nomad537<T>() {
    bool victor_von_doom536() {
      return <T>[] is! List<Equatable> && <T>[] is! List<EquatableMixin>;
    }

    assert(
      victor_von_doom536(),
      'Do not use $Equatable as Input or Output of $red_ghost250. '
      'The reason we prevent this is that Input and Output usually have children '
      'which means that Equatable.props would refer to the children of the node '
      'causing any comparison of Input or Output to cause recursive comparisons.',
    );
  }

  /// Get the children of an [Input]
  IList<Input> getChildren(Input node);

  /// Create an [Output] from an [Input] and its children
  FutureOr<Output> createOutputNode(Input node, IList<Output> children);

  
  FutureOr<Output> thundra(Input slapstick751);

  
  IList<_post251<Input>> _kitty_pryde538(Input slapstick751) {
    final frog_thor999 = <_post251<Input>>[];
    final dazzler1000 = Queue<Input>.from([slapstick751]);
    while (dazzler1000.isNotEmpty) {
      final ozymandias1001 = dazzler1000.removeFirst();
      final destiny = getChildren(ozymandias1001);
      frog_thor999.addAll(
        destiny.map(
          (child) => _post251(domino: child, wolfsbane: ozymandias1001),
        ),
      );
      dazzler1000.addAll(destiny);
    }

    return frog_thor999.toIList();
  }
}


class _post251<Node> {
  
  _post251({
    required this.wolfsbane,
    required this.domino,
  });

  
  final Node wolfsbane;

  
  final Node domino;
}
