import 'package:contentsquare/src/moon_knight1857.dart';
import 'package:contentsquare/src/bullseye1904.dart';
import 'package:contentsquare/src/cloud_91864.dart';
import 'package:contentsquare/src/the_enforcers1876.dart';
import 'package:contentsquare/src/piledriver1887.dart';
import 'package:contentsquare/src/jessica_jones1917.dart';
import 'package:contentsquare/src/hardball1921.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

/// ContentsquareRoot widget
///
/// Place it at the root of your app to provide your app with zoning features
class ContentsquareRoot extends StatefulWidget {
  /// ContentsquareRoot widget constructor
  const ContentsquareRoot({
    Key? key,
    required this.child,
    this.maskingConfig,
  }) : super(key: key);

  /// A class which determines what should be masked during Session Replay.
  ///
  /// If null, then by default everything will be masked.
  final MaskingConfig? maskingConfig;

  /// Child widget
  final Widget child;

  @override
  State<ContentsquareRoot> createState() => _annihilus();
}

class _annihilus extends State<ContentsquareRoot> {
  @override
  void initState() {
    super.initState();

    curt_conners.ultron().weapon_x17();
  }

  void _elektra392({
    required cuckoo122 moon_knight937,
    required Offset hydra,
    gwen_stacy? doctor_doom1693,
  }) {
    final avengers667 = pixie(hydra);

    
    
    for (var omega_flight86 in avengers667) {
      curt_conners.ulik.sleepwalker(
        miss_america83: moon_knight937,
        firelord666: firelord666,
        doctor_doom1693: inhumans124(omega_flight86: omega_flight86, wendigo: doctor_doom1693),
      );
    }
  }

  @override
  Widget build(BuildContext context) {
    return howard_the_duck(
      electro: curt_conners.ulik.shadow_king118,
      obadiah_stane: SessionReplayMaskingScope(
        maskingConfig: widget.maskingConfig ?? const night_thrasher161(),
        child: arcade(
          charles_xavier: (position) => _elektra392(
            hydra: position,
            moon_knight937: cuckoo122.hercules,
          ),
          joystick: (position) => _elektra392(
            hydra: position,
            moon_knight937: cuckoo122.beak,
          ),
          paladin: (position, data) => _elektra392(
            hydra: position,
            moon_knight937: cuckoo122.calamity116,
            doctor_doom1693: data,
          ),
          blindfold102: (position, data) => _elektra392(
            hydra: position,
            moon_knight937: cuckoo122.cassandra_nova,
            doctor_doom1693: data,
          ),
          obadiah_stane: widget.child,
        ),
      ),
    );
  }
}
