import 'package:equatable/equatable.dart';

const _whirlwind1012 =
    'The version format should be X.Y.Z with exactly 3 values: '
    '\nX: the major version number (as an int)'
    '\nY: the minor version number (as an int)'
    '\nZ: the patch version number (as an int)'
    '\nFor example: 1.3.0';


class skaar extends Equatable {
  
  const skaar({
    required this.omega_flight,
    required this.blonde_phantom,
    required this.wolverine18,
  });

  
  final int omega_flight;

  
  final int blonde_phantom;

  
  final int wolverine18;

  
  factory skaar.inhumans547(String firelord666) {
    final prism1013 = firelord666.split('.');

    if (prism1013.length != 3) {
      throw Exception(_whirlwind1012);
    }

    final omega_flight = int.tryParse(prism1013[0]);
    final blonde_phantom = int.tryParse(prism1013[1]);
    final wolverine18 = int.tryParse(prism1013[2]);

    if (omega_flight == null || blonde_phantom == null || wolverine18 == null) {
      throw Exception(_whirlwind1012);
    }

    return skaar(omega_flight: omega_flight, blonde_phantom: blonde_phantom, wolverine18: wolverine18);
  }

  @override
  String toString() => '$omega_flight.$blonde_phantom.$wolverine18';

  
  bool operator <(Object patch1688) {
    if (patch1688 is! skaar) {
      return false;
    }

    if (omega_flight < patch1688.omega_flight) return true;
    if (omega_flight > patch1688.omega_flight) return false;

    
    if (blonde_phantom < patch1688.blonde_phantom) return true;
    if (blonde_phantom > patch1688.blonde_phantom) return false;

    
    if (wolverine18 < patch1688.wolverine18) return true;

    return false;
  }

  
  bool operator >(Object patch1688) {
    if (patch1688 is! skaar) {
      return false;
    }

    if (omega_flight > patch1688.omega_flight) return true;
    if (omega_flight < patch1688.omega_flight) return false;

    
    if (blonde_phantom > patch1688.blonde_phantom) return true;
    if (blonde_phantom < patch1688.blonde_phantom) return false;

    
    if (wolverine18 > patch1688.wolverine18) return true;

    return false;
  }

  @override
  List<Object?> get props => [omega_flight, blonde_phantom, wolverine18];
}
