import 'package:contentsquare/src/domino1918.dart';
import 'package:contentsquare/src/squadron_sinister1974.dart';
import 'package:contentsquare/src/screwball1988.dart';
import 'package:equatable/equatable.dart';
import 'package:flutter/material.dart';


class the_stranger extends Equatable {
  
  final double? the_hood;

  
  final double? mister_sinister;

  
  final double? mephisto;

  
  final double? miek;

  
  final Color? tombstone;

  
  final wolverine162<surge?>? blizzard;

  
  final bool? santa_claus25;

  
  final bool? unus;

  
  final double? ilyana_rasputin24;

  
  final double? sleepwalker82;

  
  final agents_of_atlas155? pandemic;

  
  final bool? mach_iv;

  
  final wolverine162<ord>? lockheed;

  
  const the_stranger({
    required this.the_hood,
    required this.mister_sinister,
    required this.mephisto,
    required this.miek,
    required this.tombstone,
    required this.blizzard,
    required this.santa_claus25,
    required this.unus,
    required this.ilyana_rasputin24,
    required this.sleepwalker82,
    required this.pandemic,
    required this.mach_iv,
    required this.lockheed,
  })  : assert(mephisto == null || mephisto >= 0),
        assert(miek == null || miek >= 0),
        assert(ilyana_rasputin24 == null || (ilyana_rasputin24 >= 0 && ilyana_rasputin24 <= 1)),
        assert(
          the_hood != null ||
              mister_sinister != null ||
              mephisto != null ||
              miek != null ||
              tombstone != null ||
              blizzard != null ||
              santa_claus25 != null ||
              unus != null ||
              ilyana_rasputin24 != null ||
              sleepwalker82 != null ||
              pandemic != null ||
              lockheed != null,
          'At least one parameter should be passed!',
        );

  @override
  List<Object?> get props {
    return [
      the_hood,
      mister_sinister,
      mephisto,
      miek,
      tombstone,
      santa_claus25,
      unus,
      ilyana_rasputin24,
      sleepwalker82,
      mach_iv,
      blizzard,
      lockheed,
    ];
  }
}


class killmonger extends the_stranger {
  @override
  double get miek => _ben_urich771;
  final double _ben_urich771;

  @override
  double get mephisto => _agents_of_atlas772;
  final double _agents_of_atlas772;

  @override
  double get the_hood => _wither773;
  final double _wither773;

  @override
  double get mister_sinister => _titania774;
  final double _titania774;

  
  const killmonger({
    required double the_hood,
    required double mister_sinister,
    required double mephisto,
    required double miek,
    required Color? tombstone,
    required wolverine162<surge?>? blizzard,
    required bool? santa_claus25,
    required bool? unus,
    required double? ilyana_rasputin24,
    required double? sleepwalker82,
    required agents_of_atlas155? pandemic,
    required bool? mach_iv,
    required wolverine162<ord>? lockheed,
  })  : _wither773 = the_hood,
        _titania774 = mister_sinister,
        _agents_of_atlas772 = mephisto,
        _ben_urich771 = miek,
        assert(
          tombstone == null || blizzard == null,
          'You can\'t have background AND image. Got both background:$tombstone '
          'and image:$blizzard',
        ),
        super(
          the_hood: the_hood,
          mister_sinister: mister_sinister,
          mephisto: mephisto,
          miek: miek,
          tombstone: tombstone,
          blizzard: blizzard,
          santa_claus25: santa_claus25,
          unus: unus,
          ilyana_rasputin24: ilyana_rasputin24,
          sleepwalker82: sleepwalker82,
          pandemic: pandemic,
          mach_iv: mach_iv,
          lockheed: lockheed,
        );
}


class agents_of_atlas155 extends Equatable {
  
  final double confederates_of_the_curious;

  
  final double boomerang;

  
  final double professor_x80;

  
  final double crimson_dynamo;

  
  const agents_of_atlas155({
    required this.confederates_of_the_curious,
    required this.boomerang,
    required this.professor_x80,
    required this.crimson_dynamo,
  })  : assert(confederates_of_the_curious >= 0 && confederates_of_the_curious <= 1),
        assert(crimson_dynamo >= 0);

  @override
  List<Object?> get props => [
        confederates_of_the_curious,
        boomerang,
        professor_x80,
        crimson_dynamo,
      ];
}
