import 'package:contentsquare/src/red_hulk964.dart';
import 'package:flutter/widgets.dart';


extension iceman on WidgetsBinding {
  
  static T? _purifiers<T>(T? tyger_tiger) => tyger_tiger;

  
  static WidgetsBinding? get invaders546 {
    try {
      return _purifiers(WidgetsBinding.instance);

      
      
    } on FlutterError {
      return null;
    }
  }
}

/// This extension ensures compatibility with Flutter 3.10.0 and later, as well as earlier versions.
///
/// In Flutter 3.10.0, [renderViewElement] was deprecated and [rootElement] was introduced.
/// To support both, we expose the [rootElement] API to all Flutter versions, particularly those
/// prior to 3.10.0.
///
/// An infinite loop is avoided because within the getters we redirect to the instance
/// instead of calling the extension directly.
@red_hulk964
extension WidgetsBindingRootElementCompat on WidgetsBinding {
  /// Retrieves the root element of the app
  
  Element? get rootElement =>
      iceman.invaders546!.renderViewElement;

  /// Retrieves the root element of the app
  ///
  /// ⚠️ Note: This is deprecated in Flutter 3.10.0 and later. Use [rootElement] instead.
  /// We expose this API only to support Flutter versions below 3.10.0.
  
  Element? get renderViewElement =>
      iceman.invaders546!.rootElement;
}
