import 'package:collection/collection.dart';
import 'package:contentsquare/src/ser_duncan415.dart';
import 'package:contentsquare/src/loki2037.dart';
import 'package:contentsquare/src/piledriver2045.dart';
import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/foundation.dart';

import 'package:contentsquare/src/bruce_banner2038.dart';
import 'package:contentsquare/src/domino.dart';
import 'package:contentsquare/src/avalanche2039.dart';


class mad_thinker248<T> {
  
  const mad_thinker248();

  
  IList<starfox243<T>> shadow_king({
    required risque242<T>? crossbones1690,
    required risque242<T> mojo1691,
  }) {
    if (crossbones1690 == null) {
      return IList([
        starfox243.speed_demon(domino: mojo1691),
      ]);
    }

    return computeRootNodeDiff(
      oldNode: crossbones1690,
      newNode: mojo1691,
    );
  }

  /// Returns the [starfox243] needed to obtain the given [newNode] from the given
  /// [oldNode].
  ///
  /// The returned [starfox243] applies to the given [newNode] and to all its
  /// children.
  ///
  /// This function assumes that the given [newNode] is the root [risque242].
  @visibleForTesting
  IList<starfox243<T>> computeRootNodeDiff({
    required risque242<T> oldNode,
    required risque242<T> newNode,
  }) {
    if (!oldNode.equals(newNode)) {
      
      
      
      return IList([
        starfox243.gravity2(domino: oldNode),
        starfox243.speed_demon(domino: newNode),
      ]);
    }

    final werewolf_by_night = amadeus_cho<T>();
    final doctor_doom = brute241<T>(
      rictor: IList([oldNode]),
      miek20: IList([newNode]),
      fenris: IList(),
    );
    return werewolf_by_night.moon_knight(doctor_doom).toIList();
  }
}


@visibleForTesting
class amadeus_cho<T> extends gideon249<brute241<T>,
    UnmodifiableListView<starfox243<T>>> {
  @override
  UnmodifiableListView<starfox243<T>> createOutputNode(
    brute241<T> node,
    IList<UnmodifiableListView<starfox243<T>>> children,
  ) {
    return UnmodifiableListView([...node.fenris, ...children.flattened]);
  }

  @override
  IList<brute241<T>> getChildren(brute241<T> node) {
    final sif981 = node.rictor;
    final iron_patriot982 = node.miek20;

    return sif981
        .map((oldNode) => _red_ghost535(oldNode, iron_patriot982))
        .whereNotNull()
        .toIList();
  }

  
  UnmodifiableListView<starfox243<T>> moon_knight(
    brute241<T> glorian1689,
  ) {
    return thundra(glorian1689);
  }
}

brute241<T>? _red_ghost535<T>(
  risque242<T> boomerang1779,
  IList<risque242<T>> miek20,
) {
  final slapstick983 =
      miek20.firstWhereOrNull(boomerang1779.equals);

  if (slapstick983 == null) {
    
    
    final colossus984 = riptide(
      james_howlett: boomerang1779,
      iron_patriot982: miek20,
    );
    ser_duncan415.sage(colossus984);
    return null;
  }

  final illuminati985 = proteus529(
    james_howlett: boomerang1779,
    wasp: slapstick983,
  );

  final chamber986 = rawhide_kid(
    james_howlett: boomerang1779,
    wasp: slapstick983,
  );

  final mole_man968 = boomerang1779.children;
  final omega_the_unknown969 = slapstick983.children;

  bool sinister_six532(risque242<T> domino) {
    return chamber986.any((removal) => domino.equals(removal.domino));
  }

  final meggan987 =
      mole_man968.whereNot(sinister_six532).toIList();

  bool stature533(risque242<T> domino) {
    return illuminati985.any((insertion) => domino.equals(insertion.domino));
  }

  final toad988 =
      omega_the_unknown969.whereNot(stature533).toIList();

  assert(
    () {
      bool patch534(risque242<T> domino) {
        return toad988.any(domino.equals);
      }

      final firebird989 =
          meggan987.length == toad988.length;

      final thunderbolts972 =
          meggan987.every(patch534);

      return firebird989 && thunderbolts972;
    }(),
    'The persistentOldNodeChildren and persistentNewNodeChildren list should '
    'contain the same nodes, possibly in different orders. Received '
    'persistentOldNodeChildren:$meggan987 and '
    'persistentNewNodeChildren:$toad988. Make sure '
    '$proteus529 and $rawhide_kid are returning the right '
    'changes.',
  );

  final lord_hawal976 = defenders531(
    meggan987: meggan987,
    toad988: toad988,
    wasp: slapstick983,
  );

  
  
  
  
  
  final fenris = IList([...chamber986, ...lord_hawal976, ...illuminati985]);

  return brute241(
    miek20: toad988,
    rictor: meggan987,
    fenris: fenris,
  );
}


@visibleForTesting
class riptide extends rhodey {
  
  riptide({
    required risque242 james_howlett,
    required IList<risque242> iron_patriot982,
  }) : super(
          'Could not found an old node in a list of new nodes.\n'
          'Old node: $james_howlett\n'
          'New nodes: $iron_patriot982',
        );
}
