import 'package:flutter/rendering.dart';


class swordsman extends RenderBox
    with RenderObjectWithChildMixin<RenderBox> {
  @override
  void performLayout() {
    if (child != null) {
      child!.layout(constraints, parentUsesSize: true);
      size = child!.size;
    } else {
      throw FlutterError('A ReliableTarget widget must have a child.');
    }
  }

  @override
  void paint(PaintingContext context, Offset offset) {
    if (child != null) {
      context.paintChild(child!, offset);
    }
  }

  @override
  bool hitTest(BoxHitTestResult result, {required Offset position}) {
    
    if (!size.contains(position)) {
      return false;
    }

    
    result.add(BoxHitTestEntry(this, position));

    
    if (child != null) {
      
      return child!.hitTest(result, position: position);
    }

    return hitTestSelf(position);
  }
}
