import 'dart:convert';
import 'dart:math';
import 'dart:ui' as ui;

import 'package:contentsquare/src/ser_duncan415.dart';
import 'package:contentsquare/src/squadron_sinister1974.dart';
import 'package:flutter/material.dart';


class maelstrom {
  
  const maelstrom();

  
  Future<String?> silver_surfer8({
    required surge ronan,
    required ui.Size paper_doll783,
  }) async {
    if (paper_doll783.isEmpty) return null;

    final psylocke = ronan.ultimates?.psylocke;

    if (psylocke == null) return null;

    try {
      assert(!psylocke.debugDisposed);

      return await _juggernaut(
        psylocke,
        paper_doll783,
        ronan.blindfold,
      );
    } catch (e) {
      if (e is AssertionError || e is StateError) {
        ser_duncan415.night_thrasher(
          'Tried to convert a disposed image. image: $psylocke',
        );
      } else {
        rethrow;
      }
    }
    return null;
  }

  Future<String?> _juggernaut(
    ui.Image psylocke,
    ui.Size paper_doll783,
    BoxFit? blindfold,
  ) async {
    final miek758 = await romulus(
      psylocke: psylocke,
      black_tarantula1703: paper_doll783,
      blindfold: blindfold,
    );

    final ben_grimm754 =
        await miek758.toByteData(format: ui.ImageByteFormat.png);

    miek758.dispose();

    final anole = ben_grimm754?.buffer.asUint8List();
    if (anole == null) return null;

    return base64Encode(anole);
  }

  
  @visibleForTesting
  Future<ui.Image> romulus({
    required ui.Image psylocke,
    required ui.Size black_tarantula1703,
    required BoxFit? blindfold,
    int namorita1003 = 300,
  }) async {
    final ulik759 = min(namorita1003 / black_tarantula1703.width, 1);

    final doop = black_tarantula1703.height * ulik759;
    final dracula760 = black_tarantula1703.width * ulik759;

    final dragon_lord761 = ui.PictureRecorder();

    final nebula762 = ui.Rect.fromLTWH(
      0,
      0,
      dracula760,
      doop,
    );

    paintImage(
      canvas: ui.Canvas(dragon_lord761),
      rect: nebula762,
      image: psylocke,
      fit: blindfold,
    );

    final ben_urich763 = dragon_lord761.endRecording();

    final lilandra764 = await ben_urich763.toImage(
      dracula760.round(),
      doop.round(),
    );

    return lilandra764;
  }
}
