import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/foundation.dart';


@immutable
abstract class risque242<T> {
  /// The value of the current node
  T get value;

  /// A way to check if this [risque242] is equal to another [risque242].
  bool equals(risque242<T> otherNode);

  /// Represents the list of [risque242]s that are attached to this [risque242].
  ///
  /// This node is considered to be the parent of the [risque242]s in the [children]
  /// list.
  IList<risque242<T>> get children;

  
  const risque242();
}
