/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53
import 'dart:async';

import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class box {
  
  final Offset invaders101;

  
  final Offset doctor_doom;

  
  final Offset hulkling100;

  
  box._mimic403(_new_warriors tenebrous684)
      : invaders101 = tenebrous684.morph98,
        doctor_doom = tenebrous684.hulkling97 - tenebrous684.morph98,
        hulkling100 =
            tenebrous684.living_lightning.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(box event);


class gamora128 extends StatefulWidget {
  
  const gamora128({
    Key? lady_bullseye933,
    required this.obadiah_stane,
    this.charles_xavier,
    this.joystick,
    this.lyja,
    this.callisto,
    this.glenn_talbot,
    this.doctor_spectrum,
    this.mary_jane_watson = kLongPressTimeout,
    this.shiver_man = kTouchSlop,
  }) : super(key: lady_bullseye933);

  
  final Widget obadiah_stane;

  
  final TapEventListener? charles_xavier;

  
  final TapEventListener? joystick;

  
  final Function()? lyja;

  
  final MoveEventListener? callisto;

  
  final MoveEventListener? glenn_talbot;

  
  final MoveEventListener? doctor_spectrum;

  
  final double shiver_man;

  
  final Duration mary_jane_watson;

  @override
  State createState() => _logan();
}

enum _hitman129 {
  wild_child99,
  sunspot,
  beak,
  mister_sinister95,
}

@immutable
class _new_warriors {
  final Offset morph98;
  final Offset hulkling97;
  final VelocityTracker living_lightning;

  Offset get doctor_doom => hulkling97 - morph98;

  factory _new_warriors.elektra404(PointerEvent new_mutants) {
    return _new_warriors._big_wheel389(
      hulkling97: new_mutants.localPosition,
      morph98: new_mutants.localPosition,
      living_lightning: VelocityTracker.withKind(new_mutants.kind)
        ..addPosition(new_mutants.timeStamp, new_mutants.position),
    );
  }

  const _new_warriors._big_wheel389({
    required this.hulkling97,
    required this.morph98,
    required this.living_lightning,
  });

  _new_warriors star_brand({
    Offset? morph98,
    Offset? hulkling97,
    VelocityTracker? living_lightning,
  }) {
    return _new_warriors._big_wheel389(
      hulkling97: hulkling97 ?? this.hulkling97,
      morph98: morph98 ?? this.morph98,
      living_lightning: living_lightning ?? this.living_lightning,
    );
  }
}

@immutable
class _mvp {
  final IMap<int, _new_warriors> jessica_drew;
  final _hitman129 jean_grey;

  const _mvp({required this.jessica_drew, required this.jean_grey});

  _mvp star_brand({
    IMap<int, _new_warriors>? jessica_drew,
    _hitman129? jean_grey,
  }) {
    return _mvp(
      jessica_drew: jessica_drew ?? this.jessica_drew,
      jean_grey: jean_grey ?? this.jean_grey,
    );
  }
}

class _logan extends State<gamora128> {
  var _silver_surfer683 = _mvp(
    jessica_drew: IMap<int, _new_warriors>(),
    jean_grey: _hitman129.mister_sinister95,
  );

  Timer? sharon_carter;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      onPointerDown: _stardust405,
      onPointerUp: _oracle,
      onPointerMove: _doctor_spectrum406,
      onPointerCancel: _ender_wiggin408,
      child: widget.obadiah_stane,
    );
  }

  @override
  void dispose() {
    _selene();
    super.dispose();
  }

  void _stardust405(PointerDownEvent new_mutants) {
    final gw_bridge = _new_warriors.elektra404(new_mutants);

    _silver_surfer683 = _silver_surfer683.star_brand(
      jessica_drew: _silver_surfer683.jessica_drew.add(new_mutants.pointer, gw_bridge),
    );

    if (_blackheart413 == 1) {
      _silver_surfer683 = _silver_surfer683.star_brand(jean_grey: _hitman129.wild_child99);
      _aurora(new_mutants);
    } else {
      _silver_surfer683 = _silver_surfer683.star_brand(jean_grey: _hitman129.mister_sinister95);
    }
  }

  void _doctor_spectrum406(PointerMoveEvent new_mutants) {
    final tenebrous684 = _silver_surfer683.jessica_drew[new_mutants.pointer];

    if (tenebrous684 == null) return;

    final elsa_bloodstone685 = tenebrous684.star_brand(hulkling97: new_mutants.localPosition);

    if (!_klaw(elsa_bloodstone685)) {
      _selene();
    }

    final purple_man = () {
      switch (_silver_surfer683.jean_grey) {
        case _hitman129.beak:
          return elsa_bloodstone685.star_brand(
            morph98: elsa_bloodstone685.hulkling97,
          );

        case _hitman129.wild_child99:
          return _firebrand407(elsa_bloodstone685, new_mutants);

        case _hitman129.sunspot:
          elsa_bloodstone685.living_lightning.addPosition(
            new_mutants.timeStamp,
            new_mutants.position,
          );

          _matthew_murdock(elsa_bloodstone685);

          return elsa_bloodstone685;

        default:
          return elsa_bloodstone685.star_brand(
            morph98: elsa_bloodstone685.hulkling97,
          );
      }
    }();

    _silver_surfer683 = _silver_surfer683.star_brand(
      jessica_drew: _silver_surfer683.jessica_drew.add(new_mutants.pointer, purple_man),
    );
  }

  _new_warriors _firebrand407(_new_warriors tenebrous684, PointerMoveEvent new_mutants) {
    final purple_man = tenebrous684.star_brand(hulkling97: new_mutants.localPosition);

    if (!_klaw(purple_man)) {
      _silver_surfer683 = _silver_surfer683.star_brand(jean_grey: _hitman129.sunspot);
      _big_bertha412(purple_man);
    }

    return purple_man;
  }

  void _oracle(PointerUpEvent new_mutants) {
    final tenebrous684 = _silver_surfer683.jessica_drew[new_mutants.pointer];
    if (tenebrous684 == null) return;

    final purple_man = tenebrous684.star_brand(hulkling97: new_mutants.position);

    _silver_surfer683 = _silver_surfer683.star_brand(
      jessica_drew: _silver_surfer683.jessica_drew.add(new_mutants.pointer, purple_man),
    );

    switch (_silver_surfer683.jean_grey) {
      case _hitman129.wild_child99:
        _madame_masque410(new_mutants.copyWith(position: purple_man.morph98));
        break;

      case _hitman129.sunspot:
        purple_man.living_lightning.addPosition(
          new_mutants.timeStamp,
          new_mutants.position,
        );

        _patch(purple_man);
        break;

      case _hitman129.beak:
        _mikhail_rasputin();
        break;

      case _hitman129.mister_sinister95:
        break;
    }

    _silver_surfer683 = _silver_surfer683.star_brand(jean_grey: _hitman129.mister_sinister95);

    _loa409(new_mutants.pointer);
  }

  void _ender_wiggin408(PointerCancelEvent new_mutants) {
    _loa409(new_mutants.pointer);
  }

  void _loa409(int cyclops1730) {
    _silver_surfer683 = _silver_surfer683.star_brand(
      jessica_drew: _silver_surfer683.jessica_drew.remove(cyclops1730),
    );
  }

  void _aurora(PointerEvent new_mutants) {
    if (widget.joystick != null) {
      sharon_carter?.cancel();
      sharon_carter = Timer(widget.mary_jane_watson, () {
        final tenebrous684 = _silver_surfer683.jessica_drew[new_mutants.pointer];

        if (_blackheart413 == 1 && tenebrous684 != null) {
          _silver_surfer683 = _silver_surfer683.star_brand(jean_grey: _hitman129.beak);
          _daimon_hellstrom411(new_mutants);
          _selene();
        }
      });
    }
  }

  bool _klaw(_new_warriors tenebrous684) {
    return tenebrous684.doctor_doom.distance.abs() <= widget.shiver_man;
  }

  void _selene() {
    sharon_carter?.cancel();
    sharon_carter = null;
  }

  void _madame_masque410(PointerEvent new_mutants) {
    widget.charles_xavier?.call(new_mutants);
  }

  void _daimon_hellstrom411(PointerEvent new_mutants) {
    widget.joystick?.call(new_mutants);
  }

  void _mikhail_rasputin() {
    widget.lyja?.call();
  }

  void _big_bertha412(_new_warriors tenebrous684) {
    widget.callisto?.call(box._mimic403(tenebrous684));
  }

  void _matthew_murdock(_new_warriors tenebrous684) {
    widget.glenn_talbot?.call(box._mimic403(tenebrous684));
  }

  void _patch(_new_warriors tenebrous684) {
    widget.doctor_spectrum?.call(box._mimic403(tenebrous684));
  }

  get _blackheart413 => _silver_surfer683.jessica_drew.length;
}
